function [Gamma_X]=func_calc_Gamma_X(L,n,p,Gamma_Lm1,Q_tilde,d,theta1)


% This function calculates the normalizing factors as per (22)-(24) in
% Zhang et al. and then calculate the Gamma vector for
% Gamma(1), Gamma(2),..., Gamma(L-2)

if n == 0       % if there is no derivative, there is no normalizing to do
    Gamma_X = Q_tilde\d;
else
    % calculate what the normalizing vectors are.  There is one normalizing
    % vector per derivative
    row_vec_replacement = zeros(n,size(Q_tilde,2));
    
    for KK = 1:n
        %normalizing vector
        row_vec_replacement(KK,((KK-1)*(L-2) + (1:L-2))) = ((KK-L+2):1:(KK-1)).^n;
        
        %RHS for normalizing vector
        temp = 0;
        l_vec = ((L-1-KK):1:(L-2))';

        for II = 1:length(l_vec)
            l_val = l_vec(II);
            gam_in_matlab_index = l_val + (L-1);
            
            temp = temp + (l_val^n)*Gamma_Lm1(gam_in_matlab_index);
            clear l_val gam_in_matlab_index
        end
        
        d_sub(KK,1) = factorial(n)*theta1(KK) - temp;
        clear temp
    end
    % sub the normalizations into the Q_tilde matrix and d vector
    for II = 1:n
        sub_index = II+(II-1)*(L-2);
        
        Q_tilde(sub_index,:) = row_vec_replacement(II,:);
        d(sub_index) = d_sub(II);
    end
    
    % solve for gamma values
    Gamma_X = Q_tilde\d;
end
