function [theta1]=func_calc_theta1_vector(L,n,p)

% This function calculates for theta1, as per section 3.2 in Chen et al.

% compile the P matrix
for JJ = 1:(L-2)
    for KK = 1:(L-2)
        
        p_index = 2*JJ-KK;
        if (p_index>=0) & (p_index<=(L-1))
            P(JJ,KK) = p(p_index + 1);
        else
            P(JJ,KK) = 0;
        end
        clear p_index
    end
end
clear JJ KK

% calculate for the c vector
for II = 1:(L-2)
    temp = 0;
    
    for KK = 0:(L-1)
        p_val = 0;
        theta_val = 0;
        if (2*II-KK)>=(L-1)
            p_val = p(KK + 1);
            theta_index = 2*II-KK;
            
            % check to make sure theta_index is always greater than or equal
            % to (L-1), such that the value of theta(theta_index) =
            % theta(L-1) as per (38)
            if theta_index>=(L-1)
                theta_val = 1;
            else
                keyboard  %if this gets called there is a problem!
            end
        end
        temp = temp + p_val*theta_val;
        clear p_val theta_index theta_val
    end
    c(II,1) = temp/(2^1);
    clear temp
end

theta1 = ((eye(size(P)) - (2^(-1))*P))\c;
theta1 = [theta1; 1];
